Index: palm/trunk/SCRIPTS/.palm.config.default
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.default	(revision 3150)
+++ palm/trunk/SCRIPTS/.palm.config.default	(revision 3151)
@@ -99,5 +99,5 @@
 # OUTPUT-commands - executed when program terminates normally
 #----------------------------------------------------------------------------
-#OC:echo "PALM job finished" | mailx user@somewhere
+#OC:echo \\\"PALM job finished\\\" | mailx user@somewhere
 
 
Index: palm/trunk/SCRIPTS/.palm.config.default.in
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.default.in	(revision 3150)
+++ palm/trunk/SCRIPTS/.palm.config.default.in	(revision 3151)
@@ -72,6 +72,4 @@
 # Lines must start with "IC:" 
 #-------------------------------------------------------------------------------
-IC:export ATP_ENABLED=1
-IC:export MPICH_GNI_BTE_MULTI_CHANNEL=disabled
 IC:ulimit  -s unlimited
 #
Index: palm/trunk/SCRIPTS/.palm.config.eddy_gfort
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.eddy_gfort	(revision 3150)
+++ palm/trunk/SCRIPTS/.palm.config.eddy_gfort	(revision 3151)
@@ -1,3 +1,3 @@
-#$Id: .palm.config.crayh 2834 2018-02-23 14:04:07Z raasch $
+#$Id: .palm.config.eddy_gfort 2834 2018-02-23 14:04:07Z raasch $
 #column 1          column 2
 #name of variable  value of variable (~ must not be used)
@@ -46,6 +46,4 @@
 # INPUT-commands, executed before running PALM - lines must start with "IC:" 
 #----------------------------------------------------------------------------
-IC:export ATP_ENABLED=1
-IC:export MPICH_GNI_BTE_MULTI_CHANNEL=disabled
 IC:ulimit  -s unlimited
 #
Index: palm/trunk/SCRIPTS/.palm.config.imuk
===================================================================
--- palm/trunk/SCRIPTS/.palm.config.imuk	(revision 3150)
+++ palm/trunk/SCRIPTS/.palm.config.imuk	(revision 3151)
@@ -23,5 +23,5 @@
 # INPUT-commands, executed before running PALM - lines must start with "IC:" 
 #----------------------------------------------------------------------------
-#IC:
+IC:ulimit -s unlimited
 #
 #----------------------------------------------------------------------------
Index: palm/trunk/SCRIPTS/palmrun
===================================================================
--- palm/trunk/SCRIPTS/palmrun	(revision 3150)
+++ palm/trunk/SCRIPTS/palmrun	(revision 3151)
@@ -27,4 +27,8 @@
 # -----------------
 # $Id$
+# removed additional listing of files to be compiled, print PALM code revision
+# in header
+# 
+# 3132 2018-07-16 11:44:58Z raasch
 # create consistent error messages in case of failed restarts,
 # check existence of remote job catalog
@@ -576,5 +580,5 @@
     then
        printf "\n  +++ no hostfile \"$hostfile\" found"
-       printf "\n      Please check line \"%hostfile ...\" in $config_file"
+       printf "\n      Please check line \"hostfile ...\" in $config_file"
        locat=config_file; exit    
     fi
@@ -943,5 +947,4 @@
 
              cd $user_source_path
-             found=false
 
              Names=$(ls -1 *.f90 2>&1)
@@ -991,21 +994,6 @@
                    printf "\n      is not listed in Makefile \n"
                    locat=source; exit
-                else
-
-                   if [[ $found = false ]]
-                   then
-                      found=true
-                      printf "\n\n  *** following user file(s) added to the"
-                      printf " files to be translated:\n      "
-                   fi
-                   printf "$filename  "
-                   if [[ $silent == false ]]
-                   then
-                      sleep 0.5
-                   fi
-
                 fi
              done
-             [[ $found = true ]]  &&  printf "\n"
              cd -  > /dev/null
           fi
@@ -1517,4 +1505,5 @@
  printf "#------------------------------------------------------------------------# \n"
  printf "| %-35s%35s | \n" "$version" "$calltime"
+ printf "| %-35s%35s | \n" "PALM code    $global_revision" " "
  printf "|                                                                        | \n"
  column1="called on:"; column2=$(hostname)
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3150)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3151)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Remaining preprocessor directive __chem removed
+! 
+! 3004 2018-04-27 12:33:25Z Giersch
 ! prr field added to ONLY-list, prr* case/pr* case/precipitation_rate_av 
 ! removed, further allocation checks implemented
@@ -532,9 +535,7 @@
 !
 !--             Chemical quantity                                           
-#if defined( __chem )                
                 IF ( air_chemistry  .AND.  trimvar(1:3) == 'kc_')  THEN
                    CALL chem_3d_data_averaging( 'allocate', doav(ii) )
                 ENDIF
-#endif
 
 !
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3150)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3151)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! remaining preprocessor define strings __check removed
+! 
+! 3136 2018-07-16 14:48:21Z suehring
 ! Limit also roughness length for heat and moisture where necessary
 ! 
@@ -372,17 +375,17 @@
 
 !-- configuration parameters (they can be setup in PALM config)
-    LOGICAL                                        ::  usm_material_model = .TRUE.        !< flag parameter indicating wheather the  model of heat in materials is used
-    LOGICAL                                        ::  usm_anthropogenic_heat = .FALSE.   !< flag parameter indicating wheather the anthropogenic heat sources (e.g.transportation) are used
-    LOGICAL                                        ::  force_radiation_call_l = .FALSE.   !< flag parameter for unscheduled radiation model calls
-    LOGICAL                                        ::  indoor_model = .FALSE.              !< whether to use the indoor model
-    LOGICAL                                        ::  read_wall_temp_3d = .FALSE.
-
-
-    INTEGER(iwp)                                   ::  building_type = 1                  !< default building type (preleminary setting)
-    INTEGER(iwp)                                   ::  land_category = 2                  !< default category for land surface
-    INTEGER(iwp)                                   ::  wall_category = 2                  !< default category for wall surface over pedestrian zone
-    INTEGER(iwp)                                   ::  pedestrian_category = 2            !< default category for wall surface in pedestrian zone
-    INTEGER(iwp)                                   ::  roof_category = 2                  !< default category for root surface
-    REAL(wp)                                       ::  roughness_concrete = 0.001_wp      !< roughness length of average concrete surface
+    LOGICAL ::  usm_material_model = .TRUE.        !< flag parameter indicating wheather the  model of heat in materials is used
+    LOGICAL ::  usm_anthropogenic_heat = .FALSE.   !< flag parameter indicating wheather the anthropogenic heat sources (e.g.transportation) are used
+    LOGICAL ::  force_radiation_call_l = .FALSE.   !< flag parameter for unscheduled radiation model calls
+    LOGICAL ::  indoor_model = .FALSE.             !< whether to use the indoor model
+    LOGICAL ::  read_wall_temp_3d = .FALSE.
+
+
+    INTEGER(iwp) ::  building_type = 1               !< default building type (preleminary setting)
+    INTEGER(iwp) ::  land_category = 2               !< default category for land surface
+    INTEGER(iwp) ::  wall_category = 2               !< default category for wall surface over pedestrian zone
+    INTEGER(iwp) ::  pedestrian_category = 2         !< default category for wall surface in pedestrian zone
+    INTEGER(iwp) ::  roof_category = 2               !< default category for root surface
+    REAL(wp)     ::  roughness_concrete = 0.001_wp   !< roughness length of average concrete surface
 !
 !-- Indices of input attributes for (above) ground floor level 
@@ -5462,5 +5465,5 @@
             ENDIF
             
-#if defined( __parallel ) && ! defined ( __check )
+#if defined( __parallel )
             CALL MPI_BARRIER( comm2d, ierr )
 #endif
@@ -5496,5 +5499,5 @@
             ENDIF
             
-#if defined( __parallel ) && ! defined ( __check )
+#if defined( __parallel )
             CALL MPI_BARRIER( comm2d, ierr )
 #endif
@@ -6816,10 +6819,10 @@
 
             ENDIF
-#if defined( __parallel ) && ! defined ( __check )
+#if defined( __parallel )
             CALL MPI_BARRIER( comm2d, ierr )
 #endif
         ENDDO
         
-        !
+!
 !--     check completeness and formal correctness of the data
         DO i = nxlg, nxrg
@@ -7253,5 +7256,5 @@
                 CALL message( 'usm_read_wall_temperature', 'PA0523', 1, 2, 0, 6, 0 )
             ENDIF
-#if defined( __parallel ) && ! defined ( __check )
+#if defined( __parallel )
             CALL MPI_BARRIER( comm2d, ierr )
 #endif